#!/usr/bin/perl -w
package MFConversion;

sub new {
    my ($class) = shift;
    my ($from, $to) = @_;
    local $_;
    my $from_mf = _read_mf($from);
    my $to_mf = _read_mf($to);
    bless {from => $from_mf,
	   from_keys => [ sort {$a <=> $b} keys %$from_mf ],
	   to => $to_mf, 
	   to_keys => [ sort { $to_mf->{$a} <=> $to_mf->{$b}} keys %$to_mf] }, 
    $class;
}

sub convert {
    my $self = shift;
    my $m = shift;
    my ($last_m, $next_m);
    for (@{$self->{from_keys}}) {
	$last_m = $next_m;
	$next_m = $_;
	last if ($next_m > $m);
    }
    my $f = abs($m-$next_m)/abs($next_m - $last_m);
    my $nd = $self->{from}{$last_m}*$f +
	$self->{from}{$next_m}*(1-$f);
    for (@{$self->{to_keys}}) {
	$last_m = $next_m;
	$next_m = $_;
	last if ($self->{to}{$next_m} > $nd);
    }

    $f = abs($nd - $self->{to}{$next_m})/abs($self->{to}{$next_m}-$self->{to}{$last_m});
    my $mass = $f*$last_m + (1-$f)*$next_m;
    return $mass;
}

sub _read_mf {
    my $file = shift;
    my %mf;
    local $_;
    open IN, "<", $file or die "Couldn't open mass function file $file!\n";
    while (<IN>) {
	next if /^\#/;
	my ($m, $p, $ap) = split;
	$mf{$m} = 10**$ap;
    }
    close IN;
    my @list = sort {$b <=> $a} keys %mf;
    my %cum_mf;
    my $dm = abs(($list[0]-$list[-1])/(@list-1));
    my $sum = $mf{shift @list}*$dm;
    for (@list) {
	$cum_mf{$_+$dm/2} = $sum;
	$sum += $mf{$_}*$dm;
    }
    return \%cum_mf;
}

1;
