#!/usr/bin/perl -w
package MFInterp;

sub new {
    my ($class) = shift;
    my ($mf) = @_;
    local $_;
    $mf = _read_mf($mf);
    bless {mf => $mf,
	   mf_keys => [ sort {$a <=> $b} keys %$mf ],
    },
    $class;
}

sub mf {
    my $self = shift;
    my $m = shift;
    my ($last_m, $next_m);
    for (@{$self->{mf_keys}}) {
	$last_m = $next_m;
	$next_m = $_;
	last if ($next_m > $m);
    }
    my $f = abs($m-$next_m)/abs($next_m - $last_m);
    my $nd = $self->{mf}{$last_m}*$f +
	$self->{mf}{$next_m}*(1-$f);
    return $nd;
}

sub _read_mf {
    my $file = shift;
    my %mf;
    local $_;
    open IN, "<", $file or die "Couldn't open mass function file $file!\n";
    while (<IN>) {
	next if /^\#/;
	my ($m, $p, $ap) = split;
	$mf{$m} = $ap;
    }
    close IN;
    return \%mf;
}

1;
