#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "../mt_rand.h"
#include "../check_syscalls.h"

struct point {
  float pos[3];
};

#define FAST3TREE_DIM 3
#define FAST3TREE_TYPE struct point
#define NUM_POINTS 1000000

#include "../fast3tree.c"

int main(void) {
  int64_t i, j;
  struct point *p = NULL;
  check_realloc_s(p, sizeof(struct point), NUM_POINTS);
  r250_init(87L);
  
  for (i=0; i<1000000; i++) {
    for (j=0; j<FAST3TREE_DIM; j++) {
      p[i].pos[j] = dr250();
    }
  }

  struct fast3tree *t = fast3tree_init(NUM_POINTS, p);
  struct fast3tree_results *res = fast3tree_results_init();
  float c[FAST3TREE_DIM] = {0, 0, 0};
  float r[FAST3TREE_DIM] = {0.2, 0.1, 0.3};
  int periodic_dims[FAST3TREE_DIM] = {0, 0, 1};
  fast3tree_find_ellipsebox_periodic(t, res, c, r, periodic_dims);
  for (i=0; i<res->num_points; i++) {
    for (j=0; j<FAST3TREE_DIM; j++) {
      printf("%f ", res->points[i]->pos[j]);
    }
    printf("\n");
  }
  return 0;
}
