#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "../smoothing.h"
#include "../bin_definitions.h"


int main(void) {
  int64_t i;
  float smf[SM_NBINS]={0};
  float smooth_smf[SM_SMOOTH_NBINS]={0};

  float sm = 10.612;
  float smoothing = 0.07;
  cloud_in_cell(sm, 1, smooth_smf, SM_SMOOTH_MIN, SM_SMOOTH_BPDEX, SM_SMOOTH_NBINS);
  smooth_bins(smooth_smf, smf, smoothing,
	      SM_SMOOTH_MIN, SM_SMOOTH_BPDEX, SM_SMOOTH_NBINS,
	      SM_MIN, SM_BPDEX, SM_NBINS);

  for (i=0; i<SM_NBINS; i++) {
    double x = SM_MIN+(i+0.5)/(double)SM_BPDEX;
    double dx = 0.5/(sqrt(2)*smoothing*SM_BPDEX);
    double exact = cdf_diff((x-sm)/(sqrt(2)*smoothing), dx);
    printf("%f %e %e\n", x, smf[i], exact);
  }
}
